/*
 *  GSet
 *  Copyright (C) 2001  William H Darrow 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <gtk/gtk.h>
#include <string.h>

void check_set();

GtkWidget *pixmap[15];
GtkWidget *status_bar;
GtkWidget *window;
GtkWidget *label;
int field[12][4];
int set[12];
int fieldsets[9][3];
int number_sets;
int connected;
int sets_in_field;
int from_a, from_b, from_c;
char blank[100];
 
void check_set() {
	int set_found = 0;
	char statustext[100];
	char labeltext[100];
	GdkPixmap *image;
	GdkPixmap *mask;
	int i;
	int x;
	int moo = 0;	
	for(i=0;i<=8;i++) {
		if((from_a == fieldsets[i][0]) || (from_a == fieldsets[i][1]) || (from_a == fieldsets[i][2])) {
			if((from_b == fieldsets[i][0]) || (from_b == fieldsets[i][1]) || (from_b == fieldsets[i][2])) {
				if((from_c == fieldsets[i][0]) || (from_c == fieldsets[i][1]) || (from_c == fieldsets[i][2])) {
					set_found = 1;
					if (connected != 1) {
						fieldsets[i][0] = 0;
						fieldsets[i][1] = 0;
						fieldsets[i][2] = 0;
						sets_in_field--;
					}
				}
			}
		}
	}
	if(set_found == 1) {
		number_sets++;
		if(connected != 1) {
			sprintf(labeltext, "Yourself:  %d", number_sets);
			gtk_label_set_text(GTK_LABEL(label), labeltext);
		}
		if (connected != 1) {
			for(i=0;i<=8;i++) {
				moo=0;
				for(x=0;x<=2;x++) {
					if((fieldsets[i][x] == from_a) || (fieldsets[i][x] == from_b) || (fieldsets[i][x] == from_c)) {
						if(!((fieldsets[i][0] == 0) && (fieldsets[i][1] == 0) && (fieldsets[i][2] == 0))) {
							sets_in_field--;
							fieldsets[i][0] = 0;
							fieldsets[i][1] = 0;
							fieldsets[i][2] = 0;
						}
					}
				}
			}
		} else {
			send_sets();
		}
		sprintf(statustext, "Number of sets in field: %d   Your score: %d", sets_in_field, number_sets);
		gtk_statusbar_push(GTK_STATUSBAR(status_bar), 1, statustext);
		if(sets_in_field == 0) {
			if (connected != 1) {
				new_field();
			}
		}
		image = gdk_pixmap_create_from_xpm(window->window, &mask, NULL, blank);
		gtk_pixmap_set(GTK_PIXMAP(pixmap[12]), image, mask);
		gtk_pixmap_set(GTK_PIXMAP(pixmap[13]), image, mask);
		gtk_pixmap_set(GTK_PIXMAP(pixmap[14]), image, mask);
		for(i=0; i<=11; i++) {
			set[i] = 0;
		}
	} else {
		if(number_sets > 0) {
			number_sets--;
			if(connected == 1) {
				lower_score();
			}
		}
		if(connected != 1) {
			sprintf(labeltext, "Yourself:  %d", number_sets);
			gtk_label_set_text(GTK_LABEL(label), labeltext);
		}
		sprintf(statustext, "Number of sets in field: %d   Your score: %d", sets_in_field, number_sets);
		gtk_statusbar_push(GTK_STATUSBAR(status_bar), 1, statustext);
		image = gdk_pixmap_create_from_xpm(window->window, &mask, NULL, blank);
		gtk_pixmap_set(GTK_PIXMAP(pixmap[12]), image, mask);
		gtk_pixmap_set(GTK_PIXMAP(pixmap[13]), image, mask);
		gtk_pixmap_set(GTK_PIXMAP(pixmap[14]), image, mask);
		remcallback(window, (void*)0);
		remcallback(window, (void*)1);
		remcallback(window, (void*)2);
	}
}


