/*
 *  GSet v0.2.6
 *  Copyright (C) 2001  William H Darrow 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
#include <gnome.h> 
#include <string.h>
#include <gtk/gtk.h>
#include <config.h>
#include <top.h>

void callback(GtkWidget *widget, gpointer data);
gint delete_event (GtkWidget *widget, GdkEvent *event, gpointer data);
void destroy(GtkWidget *widget, gpointer data);
void remcallback(GtkWidget *widget, gpointer data);

GtkWidget *pixmap[15];
GtkWidget *window, *label, *status_bar;
char blank[100];
int sockfd;
int identifier;
int connected;

gint delete_event (GtkWidget *widget, GdkEvent *event, gpointer data) {
	if (connected == 1) {
		gdk_input_remove(identifier);
		close(sockfd);
	}
	return(FALSE);
}

void destroy(GtkWidget *widget, gpointer data) {
	gtk_main_quit();
}

int main(int argc, char *argv[]) {
	GtkWidget *table;
	GdkPixmap *image;
	GdkPixmap *mask;
	GtkWidget *vbox, *main_vbox;
	GtkWidget *button;
	GtkWidget *hbox;
	GtkWidget *menubar;
	GtkWidget *toolbar;
	GtkWidget *icon;
	GtkWidget *close_button;
	GtkWidget *handlebox;
	GtkWidget *frame;
	int i, r, n;
	
	gnome_init(PACKAGE, VERSION, argc, argv);  
	window = gnome_app_new(PACKAGE, _("GSet!"));
	create_menus(window);
	strcpy(blank, PIXPATH);
	strcat(blank, "blank.xpm");
	main_vbox = gtk_vbox_new(FALSE,1);
	gnome_app_set_contents(GNOME_APP(window), main_vbox);
	hbox = gtk_hbox_new(FALSE,0);

	gtk_signal_connect(GTK_OBJECT(window), "delete_event", GTK_SIGNAL_FUNC(delete_event), NULL);
	gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(destroy), NULL);
	
	gtk_window_set_title(GTK_WINDOW(window), "GSet!");
	
	table = gtk_table_new(3,5, TRUE);
	image = gdk_pixmap_create_from_xpm(window->window, &mask, NULL, blank);
	for(i=0;i<=2;i++) {
		for(r=0;r<=3;r++) {
			n = (i*4) + r;
			pixmap[n] = gtk_pixmap_new(image, mask);
			button = gtk_button_new();
			gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(callback), (void*)n);
			gtk_container_add(GTK_CONTAINER(button), pixmap[n]);
			gtk_widget_show(button);
			gtk_widget_show(pixmap[n]);
			gtk_table_attach(GTK_TABLE(table), button, r, (r+1), i, (i+1), GTK_FILL, GTK_FILL, BORDERSPACE, BORDERSPACE);
		}
	}
	
	frame = gtk_frame_new("Scores");
	label = gtk_label_new("Yourself:  0");
	gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
	gtk_container_add(GTK_CONTAINER(frame), label);
	gtk_table_attach(GTK_TABLE(table), frame, 4, 5, 2, 3, GTK_FILL, GTK_FILL, BORDERSPACE, BORDERSPACE);
	gtk_widget_show(label);
	gtk_widget_show(frame);
	
	gtk_box_pack_start(GTK_BOX(hbox), table, FALSE, FALSE, 0);
	gtk_widget_show(table);
	
	table = gtk_table_new(3,1, TRUE);
	for(i=0;i<=2;i++) {
		n=i+12;
		button = gtk_button_new();
		gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(remcallback), (void*)i);
		pixmap[n] = gtk_pixmap_new(image, mask);
		gtk_container_add(GTK_CONTAINER(button), pixmap[n]);
		gtk_table_attach(GTK_TABLE(table), button, 0, 1, i, (i+1), GTK_FILL, GTK_FILL, BORDERSPACE, BORDERSPACE);
		gtk_widget_show(button);
		gtk_widget_show(pixmap[n]);
	}

	gtk_box_pack_end(GTK_BOX(hbox), table, FALSE, FALSE, 0);
	gtk_widget_show(table);
	
	status_bar = gtk_statusbar_new();
	gtk_box_pack_end(GTK_BOX(main_vbox), status_bar, FALSE, TRUE, 0);
	gtk_statusbar_push(GTK_STATUSBAR(status_bar), 1, "Welcome to Gset");
	gtk_widget_show(status_bar);
	
	gtk_box_pack_start(GTK_BOX(main_vbox), hbox, FALSE, TRUE, 0);
	gtk_widget_show(hbox);
	gtk_widget_show(main_vbox);
	gtk_widget_show(window);

	gtk_main();
	return(0);
}

