/*
 *  GSet
 *  Copyright (C) 2001  William H Darrow 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <config.h>

void new_game();
void new_field();
void remcallback(GtkWidget *widget, gpointer data);
void callback(GtkWidget *widget, gpointer data);

GtkWidget *pixmap[15];
GtkWidget *status_bar;
GtkWidget *window;
GtkWidget *label;
int sockfd;
int identifier;
int field[12][4];
int set[12];
int fieldsets[9][3];
int number_sets;
int sets_in_field;
int from_a, from_b, from_c;
int connected;
char blank[100];

void new_game() {
	number_sets = 0;
	new_field();
}
 
void new_field() {
	int numeric;
	int i, x, r, t;
	int k=0;
	int fail=1;
	char labeltext[100];
	sets_in_field=0;
	if(connected == 1) {
		gdk_input_remove(identifier);
		close(sockfd);
		connected = 0;
	}
	srand((unsigned)time(NULL));
	for(i=0;i<=8;i++) {
		for(x=0;x<=2;x++) {
			fieldsets[i][x] = 0;
		}
	}
	sprintf(labeltext, "Yourself:  %d", number_sets);
	gtk_label_set_text(GTK_LABEL(label), labeltext);
	for(x=0; x<=11; x++) {
		for(i=0; i<=3; i++) {
			numeric = 0;
			while(numeric == 0) {
				numeric=rand()%4;
			}
			field[x][i] = numeric;
		}
	}
	while(fail==1) {
		fail=0;
		for(x=0;x<=11;x++) {
			for(r=0;r<=11;r++) {
				if(field[x][0]==field[r][0] && field[x][1]==field[r][1] && field[x][2]==field[r][2] && field[x][3]==field[r][3] && x!=r) {
					fail = 1;
					for(i=0; i<=3; i++) {
						numeric = 0;
						while(numeric == 0) {
							numeric=rand()%4;
						}
						field[x][i] = numeric;
					}
				}
			}
		}
	}
	for(x=0; x<=11; x++) {
		for(r=x+1; r<=11; r++) {
			for(t=r+1; t<=11; t++) {
				if((field[x][0] == field[r][0] && field[r][0] == field[t][0]) || (field[x][0] != field[r][0] && field[r][0] != field[t][0] && field[x][0] != field[t][0])) {
					if((field[x][1] == field[r][1] && field[r][1] == field[t][1]) || (field[x][1] != field[r][1] && field[r][1] != field[t][1] && field[x][1] != field[t][1])) {
						if((field[x][2] == field[r][2] && field[r][2] == field[t][2]) || (field[x][2] != field[r][2] && field[r][2] != field[t][2] && field[x][2] != field[t][2])) {
							if((field[x][3] == field[r][3] && field[r][3] == field[t][3]) || (field[x][3] != field[r][3] && field[r][3] != field[t][3] && field[x][3] != field[t][3])) {
								fieldsets[k][0] = x;
								fieldsets[k][1] = r;
								fieldsets[k][2] = t;
								k++;
								sets_in_field++;
							}
						}
					}
				}
			}
		}
	}
	if(sets_in_field == 0) {
		new_field();
	} else {
		mnew_field();
	}
}
 
void remcallback(GtkWidget *widget, gpointer data) {
	int card = (int)data;
	int cardinarray;
	GdkPixmap *image;
	GdkPixmap *mask;
	int i;
	int putinfield = 0;
	char ax[5];
	char bx[5];
	char cx[5];
	char dx[5];
	char name[100];
	cardinarray = card * 4;
	if(set[cardinarray] != 0) {
		image = gdk_pixmap_create_from_xpm(window->window, &mask, NULL, blank);
		switch(card) {
			case 0: gtk_pixmap_set(GTK_PIXMAP(pixmap[12]), image, mask); putinfield=from_a; break;
			case 1: gtk_pixmap_set(GTK_PIXMAP(pixmap[13]), image, mask); putinfield=from_b; break;
			case 2: gtk_pixmap_set(GTK_PIXMAP(pixmap[14]), image, mask); putinfield=from_c; break;
		}
		field[putinfield][0] = set[cardinarray];
		field[putinfield][1] = set[cardinarray+1];
		field[putinfield][2] = set[cardinarray+2];
		field[putinfield][3] = set[cardinarray+3];
		sprintf(ax, "%d", field[putinfield][0]);
		sprintf(bx, "%d", field[putinfield][1]);
		sprintf(cx, "%d", field[putinfield][2]);
		sprintf(dx, "%d", field[putinfield][3]);
		strcpy(name, PIXPATH);
		strcat(name, ax);
		strcat(name, bx);
		strcat(name, cx);
		strcat(name, dx);
		strcat(name, ".xpm");
		image = gdk_pixmap_create_from_xpm(window->window, NULL, NULL, name);
		gtk_pixmap_set(GTK_PIXMAP(pixmap[putinfield]), image, NULL);
		for(i=0; i<=3; i++) {
			set[cardinarray+i] = 0;
		}
	}
}

void callback(GtkWidget *widget, gpointer data) {
	GdkPixmap *image;
	GdkPixmap *mask;
	char a[2];
	char b[2];
	char c[2];
	char d[2];
	char name[100];
	int i;
	int moo = 0;
	if(field[(int)data][0] != 0) {
		sprintf(a, "%d", field[(int)data][0]);
		sprintf(b, "%d", field[(int)data][1]);
		sprintf(c, "%d", field[(int)data][2]);
		sprintf(d, "%d", field[(int)data][3]);
		strcpy(name, PIXPATH);
		strcat(name, a);
		strcat(name, b);
		strcat(name, c);
		strcat(name, d);
		strcat(name, ".xpm");
		image = gdk_pixmap_create_from_xpm(window->window, NULL, NULL, name);
		if(set[0] == 0) {
			set[0] = field[(int)data][0];
			set[1] = field[(int)data][1];
			set[2] = field[(int)data][2];
			set[3] = field[(int)data][3];
			gtk_pixmap_set(GTK_PIXMAP(pixmap[12]), image, NULL);
			from_a = (int)data;
		} else if(set[4] == 0) {
			set[4] = field[(int)data][0];
			set[5] = field[(int)data][1];
			set[6] = field[(int)data][2];
			set[7] = field[(int)data][3];
			gtk_pixmap_set(GTK_PIXMAP(pixmap[13]), image, NULL);
			from_b = (int)data;
		} else if(set[8] == 0) {
			set[8] = field[(int)data][0];
			set[9] = field[(int)data][1];
			set[10] = field[(int)data][2];
			set[11] = field[(int)data][3];
			gtk_pixmap_set(GTK_PIXMAP(pixmap[14]), image, NULL);
			from_c = (int)data;
			moo = 1;
		}
		image = gdk_pixmap_create_from_xpm(window->window, &mask, NULL, blank);
		gtk_pixmap_set(GTK_PIXMAP(pixmap[(int)data]), image, mask);
		for(i=0; i<=3; i++) {
			field[(int)data][i] = 0;
		}
		if(moo == 1) {
			check_set();
		}
	}
}


 