/*
 *  GSet 
 *  Copyright (C) 2001  William H Darrow 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

void new_game();
void new_field();
void create_menus (GtkWidget *app);
void about_cb(GtkWidget *widget, gpointer data);
void broken_cb(GtkWidget *widget, gpointer data);
void connect_cb(GtkWidget *widget, gpointer data);
void entry_cb(GtkWidget *widget, gpointer data);
void auth_cb(GtkWidget *widget, gpointer data);
void aentry_cb(GtkWidget *widget, gpointer data);
void begin_cb(GtkWidget *widget, gpointer data);
void disconnect_cb(GtkWidget *widget, gpointer data);
gint chcdial(GtkWidget *widget, gpointer data);
void trigger();

GtkWidget *dialog;
GtkWidget *status_bar;
int sockfd;
int identifier;
int connected;
int cdial;
GtkWidget *entry[3];
char statustext[100];

GnomeUIInfo game_menuinfo[] = {
	GNOMEUIINFO_MENU_NEW_GAME_ITEM(new_game, NULL),
	GNOMEUIINFO_MENU_RESTART_GAME_ITEM(new_field, NULL),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_UNDO_MOVE_ITEM(broken_cb, NULL), 
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_SCORES_ITEM(broken_cb, NULL),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_EXIT_ITEM(gtk_main_quit, NULL),
	GNOMEUIINFO_END
};

GnomeUIInfo mp_menuinfo[] = {
	GNOMEUIINFO_ITEM(N_("_Connect..."), N_("Connect to server"), connect_cb, NULL),
	GNOMEUIINFO_ITEM(N_("_Disconnect"), N_("Disconnect from server"), disconnect_cb, NULL),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_ITEM(N_("_Authenticate..."), N_("Authenticate as server administrator"), auth_cb, NULL),
	GNOMEUIINFO_ITEM(N_("_Begin game"), N_("Send command to server to begin game"), begin_cb, NULL),
	GNOMEUIINFO_END
};

GnomeUIInfo settings_menuinfo[] = {
	GNOMEUIINFO_ITEM_STOCK(N_("Game _options..."), N_("Modify the options for this game"), broken_cb, GNOME_STOCK_MENU_PREF),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_PREFERENCES_ITEM(broken_cb, NULL),
	GNOMEUIINFO_END
};

GnomeUIInfo help_menuinfo[] = {
	GNOMEUIINFO_HELP("gset"),
	GNOMEUIINFO_MENU_ABOUT_ITEM(about_cb, NULL),
	GNOMEUIINFO_END
};
  
GnomeUIInfo main_menuinfo[] = {
	GNOMEUIINFO_MENU_GAME_TREE(game_menuinfo),
	GNOMEUIINFO_SUBTREE(N_("_Multiplayer"), mp_menuinfo),
	GNOMEUIINFO_MENU_SETTINGS_TREE(settings_menuinfo),
	GNOMEUIINFO_MENU_HELP_TREE(help_menuinfo),
	GNOMEUIINFO_END
};

GnomeUIInfo main_toolbarinfo[] = {
	GNOMEUIINFO_ITEM_STOCK(N_("New"), N_("Deal a new game"), new_game, GNOME_STOCK_PIXMAP_NEW),
	GNOMEUIINFO_ITEM_STOCK(N_("Restart"), N_("Deal this hand again, but do not reassign score"), new_field, GNOME_STOCK_PIXMAP_REFRESH),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_ITEM_STOCK(N_("Undo"), N_("Undo the last move"), broken_cb, GNOME_STOCK_PIXMAP_UNDO),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_ITEM_STOCK(N_("Score"), N_("View the scores"), broken_cb, GNOME_STOCK_PIXMAP_SCORES),
	GNOMEUIINFO_ITEM_STOCK(N_("Props"), N_("Configure GSet"), broken_cb, GNOME_STOCK_PIXMAP_PROPERTIES),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_ITEM_STOCK(N_("Exit"), N_("Quit GSet"), gtk_main_quit, GNOME_STOCK_PIXMAP_EXIT),
	GNOMEUIINFO_END
};

void create_menus (GtkWidget *app) {
	gnome_app_create_menus_with_data (GNOME_APP(app), main_menuinfo, app);
	gnome_app_create_toolbar_with_data (GNOME_APP(app), main_toolbarinfo, app);
}

void about_cb(GtkWidget* widget, gpointer data) {
	GtkWidget* dialog = NULL;
	GtkWidget* app;
	app = (GtkWidget*) data;
	if (dialog != NULL) {
		g_assert(GTK_WIDGET_REALIZED(dialog));
		gdk_window_show(dialog->window);
		gdk_window_raise(dialog->window);
    } else {        
		const gchar *authors[] = {
        	"William H Darrow <setrinet.sourceforge.net>", 
        	NULL
		};
		gchar* logo = gnome_pixmap_file("gnome-gset-logo.png");
		dialog = gnome_about_new (_("GSet"), VERSION, "(C) 2001 William H Darrow", authors, _("A GPL'd set card game in GTK+"), logo);
		g_free(logo);
		gtk_signal_connect(GTK_OBJECT(dialog), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroyed), &dialog);
		gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(app));
		gtk_widget_show(dialog);
    }
}

void broken_cb(GtkWidget* widget, gpointer data) {
	GtkWidget *dialog;
	GtkWidget *app;
	app = (GtkWidget*) data;
	dialog = gnome_ok_dialog_parented(_("This feature is not available yet.  Please wait for the next version, but do not submit a bug report!"), GTK_WINDOW(app));
}

void connect_cb(GtkWidget *widget, gpointer data) {
	GtkWidget *label;
	GtkWidget *table;
	GtkWidget *button;
	char port[5];
	sprintf(port, "%d", PORT);
	if (connected != 1 && cdial != 1) {
		cdial = 1;
		dialog = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_signal_connect(GTK_OBJECT(dialog), "delete_event", GTK_SIGNAL_FUNC(chcdial), NULL);
		gtk_container_set_border_width(GTK_CONTAINER(dialog), 15);
		table = gtk_table_new(4, 2, FALSE);
		label = gtk_label_new("Address ");
		gtk_table_attach(GTK_TABLE(table), label, 0, 1, 0, 1, GTK_FILL, GTK_FILL, 0, 0);
		gtk_widget_show(label);
		entry[0] = gtk_entry_new_with_max_length(50);
		gtk_signal_connect(GTK_OBJECT(entry[0]), "activate", GTK_SIGNAL_FUNC(entry_cb), NULL);
		button = gtk_button_new_with_label("Connect -->");
		gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(entry_cb), NULL);
		gtk_table_attach(GTK_TABLE(table), entry[0], 1, 2, 0, 1, GTK_FILL, GTK_FILL, 0, 0);
		label = gtk_label_new("Port ");
		gtk_table_attach(GTK_TABLE(table), label, 0, 1, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
		gtk_widget_show(label);
		entry[1] = gtk_entry_new_with_max_length(5);
		gtk_entry_set_text(GTK_ENTRY(entry[1]), port);
		gtk_table_attach(GTK_TABLE(table), entry[1], 1, 2, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
		label = gtk_label_new("Username ");
		gtk_table_attach(GTK_TABLE(table), label, 0, 1, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
		gtk_widget_show(label);
		entry[2] = gtk_entry_new_with_max_length(7);
		gtk_entry_set_text(GTK_ENTRY(entry[2]), USRNM);
		gtk_table_attach(GTK_TABLE(table), entry[2], 1, 2, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
		gtk_table_attach(GTK_TABLE(table), button, 1, 2, 4, 5, GTK_FILL, GTK_FILL, 40, 10);
		gtk_container_add(GTK_CONTAINER(dialog), table);
		gtk_widget_show(entry[0]);
		gtk_widget_show(entry[1]);
		gtk_widget_show(entry[2]);
		gtk_widget_show(button);
		gtk_widget_show(table);
		gtk_widget_show(dialog);
	}
}

void entry_cb(GtkWidget *widget, gpointer data) {
	char *entry_texta;
	char *entry_textb;
	char *entry_textc;
	int passer;
	cdial = 0;
	entry_texta = gtk_entry_get_text(GTK_ENTRY(entry[0]));
	entry_textb = gtk_entry_get_text(GTK_ENTRY(entry[1]));
	entry_textc = gtk_entry_get_text(GTK_ENTRY(entry[2]));
	passer = atoi(entry_textb);
	if((strlen(entry_textc)) > 0) {
		start_recv(entry_texta, passer, entry_textc);
	} else {
		strcpy(statustext, "Bad user name!");
		gtk_statusbar_push(GTK_STATUSBAR(status_bar), 1, statustext);
	}
	gtk_widget_destroy(dialog);
}

void auth_cb(GtkWidget *widget, gpointer data) {
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *entryq;
	GtkWidget *hbox;
	GtkWidget *button;
	if (connected == 1) {
		dialog = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_container_set_border_width(GTK_CONTAINER(dialog), 15);
		label = gtk_label_new("Please enter the server password");
		vbox=gtk_vbox_new(FALSE, 1);
		hbox=gtk_hbox_new(FALSE, 1);
		gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
		entryq = gtk_entry_new_with_max_length(50);
		gtk_signal_connect(GTK_OBJECT(entryq), "activate", GTK_SIGNAL_FUNC(aentry_cb), entryq);
		button = gtk_button_new_with_label("Accept");
		gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(aentry_cb), entryq);
		gtk_box_pack_start(GTK_BOX(hbox), entryq, FALSE, FALSE, 0);
		gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);
		gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
		gtk_container_add(GTK_CONTAINER(dialog), vbox);
		gtk_widget_show(entryq);
		gtk_widget_show(button);
		gtk_widget_show(hbox);
		gtk_widget_show(label);
		gtk_widget_show(vbox);
		gtk_widget_show(dialog);
	}
}

void aentry_cb(GtkWidget *widget, gpointer data) {
	char *entry_text;
	entry_text = gtk_entry_get_text(GTK_ENTRY(data));
	send_auth(entry_text);
	gtk_widget_destroy(dialog);
}

void begin_cb(GtkWidget *widget, gpointer data) {
	char retbuf[100];
	char statustext[100];
	if(connected == 1) {
		send(sockfd, "B", 1, 0);
	}
}
	
void disconnect_cb(GtkWidget *widget, gpointer data) {
	if(connected == 1) {
		clrall();
		gdk_input_remove(identifier);
		close(sockfd);
		gtk_statusbar_push(GTK_STATUSBAR(status_bar), 1, "Disconnected from server");
		connected = 0;
	}
}

gint chcdial(GtkWidget *widget, gpointer data) {
	cdial = 0;
	return FALSE;
}





